#include <bits/stdc++.h>
using namespace std;

int minAliPozitivan(int a, int b){  // vraca manji broj ili ako je taj negativan, vraca veci
    if (a < 0) {
        return b;
    }

    if (b < 0) {
        return a;
    }

    if (a < b) {
        return a;
    }

    return b;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int N, M, Q, zabX, zabY;
    cin >> N >> M;

    int navijaci[N][M];
    for (int i = 0; i < N; i++){
        for (int j = 0; j < M; j++){
            cin >> navijaci[i][j];
        }
    }

    cin >> Q;
    long long brojNavijaca[N][M];
    int kolona;
    brojNavijaca[0][0] = navijaci[0][0];
    for (int nebitno = 0; nebitno < Q; nebitno++){
        cin >> zabX >> zabY;
        zabX--;
        zabY--;

        for (int dijagonala = 1; dijagonala < N + M - 1; dijagonala++){
            for (int red = 0; red < N; red++){
                kolona = dijagonala - red;
                if (kolona >= 0 && kolona < M){
                    
                    if (zabX == red && zabY == kolona){
                        brojNavijaca[red][kolona] = -1;     // -1 oznacava zabranjeno polje i polja koja su nedostižna
                    } else {
                        if (kolona == 0){
                            if (brojNavijaca[red-1][0] == -1){
                                brojNavijaca[red][0] = -1;
                            } else {
                                brojNavijaca[red][0] = brojNavijaca[red-1][0] + navijaci[red][0];
                            }
                        } else if (red == 0){
                            if (brojNavijaca[0][kolona-1] == -1){
                                brojNavijaca[0][kolona] = -1;
                            } else {
                                brojNavijaca[0][kolona] = brojNavijaca[0][kolona-1] + navijaci[0][kolona];
                            }
                        } else {
                            brojNavijaca[red][kolona] = minAliPozitivan(brojNavijaca[red][kolona-1], brojNavijaca[red-1][kolona]) + navijaci[red][kolona];
                        }
                    }

                }
            }
        }

        cout << brojNavijaca[N-1][M-1] << "\n";
    }
}